// Popescu Teodor, 333 CB

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

#define DELAY 1000

int leds[16] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7, PC7, PC6, PC5, PC4, PC3, PC2, PC1, PC0};
int lines[4] = {PD4, PD5, PD6, PD7};

void effect1(){
	int i;

	PORTA = 0xFF;
	PORTC = 0xFF;

	for (i = 4096; i > 0; i/=2){
		PORTD = 0xF0;
		
		_delay_ms(i);

		PORTD = 0x00;
		
		_delay_ms(i);
	}
}



void effect2(){
	int i, j, iter;
	
	for (iter = 0; iter < 1; iter++){
		_delay_ms(2000);
		PORTD = 0b00010000;
		
		for (i = 0; i < 4; i++) {
			_delay_ms(1000);
			PORTA = 0b00000001;
			PORTC = 0x00;
			
			for (j = 0; j < 3; j++) {
				_delay_ms(2000);
				PORTA |= PORTA << 1;
			}

			_delay_ms(2000);
			PORTA |= 1 << 7;

			for (j = 0; j < 3; j++){
				_delay_ms(2000);
				PORTA |= PORTA >> 1;
			}
			
			_delay_ms(2000);
			PORTC = 0b10000000;
			PORTA = 0b11111111;

			for (j = 0; j < 3; j++){
				_delay_ms(2000);
				PORTC |= PORTC >> 1;
			}
			
			_delay_ms(2000);
			PORTC |= 1;
			
			for (j = 0; j < 3; j++){
				_delay_ms(2000);
				PORTC |= PORTC << 1;
			}
			
			_delay_ms(3000);
			PORTA = 0x00;
			PORTC = 0x00;
			_delay_ms(3000);
			PORTA = 0xFF;
			PORTC = 0xFF;
			_delay_ms(3000);
			PORTA = 0x00;
			PORTC = 0x00;
			_delay_ms(3000);
			PORTA = 0xFF;
			PORTC = 0xFF;
			_delay_ms(6000);
			PORTA = 0b11011110;
			PORTC = 0b11011110;
			_delay_ms(3000);
			PORTA = 0b10001100;
			PORTC = 0b10001100;
			_delay_ms(3000);
			PORTA = 0b00001000;
			PORTC = 0b00001000;
			_delay_ms(3000);
			PORTA = 0b00000000;
			PORTC = 0b00000000;
			
			_delay_ms(3000);
			PORTD |= PORTD << 1;
		}
	}
}



void effect3(){
	int i, delay = 1000;
	
	for (i = 0; i < 50; i++){
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b01000000;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b01000000;
		_delay_ms(delay);
		
		delay -= 20;
	}
}





void effect4(){
	int i, delay = 1200;
	
	PORTA = 0;
	PORTC = 0;
	PORTD = 0;
	
	for (i = 0; i < 100; i++){
		PORTD = 0b10000000;
		PORTA = 1 << (rand() % 8);
		PORTC = 1 << (rand() % 8);
		PORTA |= 1 << (rand() % 8);
		PORTC |= 1 << (rand() % 8);
		_delay_ms(delay);
		
		PORTD = 0b01000000;
		_delay_ms(delay/2);
		
		PORTD = 0b00100000;
		_delay_ms(delay/3);
		
		PORTD = 0b00010000;
		_delay_ms(delay/4);
		
		PORTD = 0b00000000;
	}
}


void effect5(){
	int i, delay;
	
	delay = DELAY/4;
	
	// letter C 
	for (i = 0; i < 100; i++){
	
//

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0b00000000;
		PORTD = 0b10000000;
		_delay_ms(delay);
//		
		
		


		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b01000000;
		_delay_ms(delay);

		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b00100000;
		_delay_ms(delay);
//
		
		PORTA = 0xF0;
		PORTC = 0b00000000;
		PORTD = 0b00010000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00010000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		delay -= 2;
	}
	
	delay = DELAY/4;
	
	// letter O 
	for (i = 0; i < 100; i++){
		PORTA = 0x0F;
		PORTC = 0b00000000;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0b00000000;
		PORTD = 0b01000000;
		_delay_ms(delay);

		PORTA = 0xF0;
		PORTC = 0b00000000;
		PORTD = 0b10000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b10000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b01000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00100000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00010000;
		_delay_ms(delay);

		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		delay -= 2;
	}
	
	delay = DELAY/4;
	
	// letter J 
	for (i = 0; i < 100; i++){
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b01000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		delay -= 2;
	}

	delay = DELAY/4;

	// letter O 
	for (i = 0; i < 100; i++){
		PORTA = 0x0F;
		PORTC = 0b00000000;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0b00000000;
		PORTD = 0b01000000;
		_delay_ms(delay);

		PORTA = 0xF0;
		PORTC = 0b00000000;
		PORTD = 0b10000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b10000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b01000000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00100000;
		_delay_ms(delay);

		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00010000;
		_delay_ms(delay);

		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		delay -= 2;
	}
}




void effect6(){
	int i, delay = 2000;
	
	PORTA = 0b00000000;
	PORTC = 0b00000000;
	_delay_ms(2*delay);
	
	PORTA = 0b00000001;
	PORTC = 0b00000000;
	PORTD = 0b11110000;
	_delay_ms(2*delay);
	
	PORTA = 0b00001001;
	PORTC = 0b00000000;
	_delay_ms(2*delay);
	
	PORTA = 0b00001001;
	PORTC = 0b00001000;
	_delay_ms(2*delay);
	
	PORTA = 0b00001001;
	PORTC = 0b00001001;
	_delay_ms(2*delay);

	PORTA = 0b00001001;
	PORTC = 0b00001000;
	_delay_ms(2*delay);
	
	PORTA = 0b00001001;
	PORTC = 0b00000000;
	_delay_ms(2*delay);
	
	PORTA = 0b00000001;
	PORTC = 0b00000000;
	_delay_ms(2*delay);
	
	for (i = 0; i < 4; i++){
		PORTA = 0b00000000;
		PORTC = 0b00000000;
		_delay_ms(delay);
		
		PORTA = 0b00000001;
		PORTC = 0b00000000;
		_delay_ms(delay);
		
		PORTA = 0b00000011;
		PORTC = 0b00000000;
		_delay_ms(delay);
		
		PORTA = 0b00000111;
		PORTC = 0b00000000;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00000000;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00010001;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00010011;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00010111;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b00011111;
		_delay_ms(delay);
		
		PORTA = 0b10001111;
		PORTC = 0b10011111;
		_delay_ms(delay);
		
		PORTA = 0b10011111;
		PORTC = 0b10011111;
		_delay_ms(delay);
		
		PORTA = 0b10111111;
		PORTC = 0b10011111;
		_delay_ms(delay);
		
		PORTA = 0b11111111;
		PORTC = 0b10011111;
		_delay_ms(delay);
		
		PORTA = 0b11111111;
		PORTC = 0b10111111;
		_delay_ms(delay);
		
		PORTA = 0b11111111;
		PORTC = 0b11111111;
		_delay_ms(delay);
		
		
		PORTA = 0b11110111;
		PORTC = 0b11110111;
		_delay_ms(delay);
		
		PORTA = 0b01110011;
		PORTC = 0b01110011;
		_delay_ms(delay);
		
		PORTA = 0b00100001;
		PORTC = 0b00100001;
		_delay_ms(delay);
		
		PORTA = 0b00000000;
		PORTC = 0b00000000;
		_delay_ms(delay);
	}
}



int main() {
	DDRA = 0xFF;
    DDRC = 0xFF;
    DDRD = 0xF0;
	
	PORTA = 0xFF;
	PORTC = 0xFF;
	PORTD = 0x00;
	
	while (1){
		_delay_ms(40000);
		
		effect1();
		
		_delay_ms(40000);
		
		effect2();
		
		_delay_ms(40000);    
		
		effect3();
		
		_delay_ms(1000);
		
		effect4();
		
		_delay_ms(40000);
		
		effect5();
		
		_delay_ms(40000);
		
		effect6();
		
		_delay_ms(40000);
		
		
	}
	
}